using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.IO;

namespace Dialogs
{
	public class LoanApplicationHelp : Dialogs.LoanApplicationToolTip
	{
		//private System.ComponentModel.IContainer components = null;

		public LoanApplicationHelp()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // okButton
            // 
            this.okButton.Location = new System.Drawing.Point(136, 210);
            // 
            // cancelButton
            // 
            this.cancelButton.Location = new System.Drawing.Point(405, 210);
            // 
            // buttonApply
            // 
            this.buttonApply.Location = new System.Drawing.Point(277, 210);
            // 
            // LoanApplicationHelp
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
            this.ClientSize = new System.Drawing.Size(549, 277);
            this.HelpButton = true;
            this.Name = "LoanApplicationHelp";
            this.HelpRequested += new System.Windows.Forms.HelpEventHandler(this.LoanApplicationHelp_HelpRequested);
            ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		// Retrieve all controls and all child controls and etc.
		// Make sure to send controls back at lowest depth first
		// so that most child controls are checked for things before
		// container controls, e.g. a TextBox is checked before a
		// GroupBox control
		protected Control[] GetAllControls() 
		{
			ArrayList list = new ArrayList();
			GetAllControls(Controls, list);
			return (Control[])list.ToArray(typeof(Control));
		}
		protected void GetAllControls(Control.ControlCollection controls, ArrayList list) 
		{
			foreach(Control control in controls) 
			{
				if(control.HasChildren) GetAllControls(control.Controls, list);
				list.Add(control);
			}
		}

		private void LoanApplicationHelp_HelpRequested(object sender, System.Windows.Forms.HelpEventArgs hlpevent)
		{
			if (Control.MouseButtons == MouseButtons.None) 
			{
				string subtopic = null;
				if (this.ActiveControl == this.applicantNameTextBox) 
				{
					subtopic = "name";
				} 
				else if (this.ActiveControl == this.applicantPhoneNoTextBox) 
				{
					subtopic = "phone";
				} 
				else if (this.ActiveControl == this.applicantLoanAmountTextBox)
				{
					subtopic = "loanAmount";
				}
                String file = Path.GetFullPath("Loan.chm");
				Help.ShowHelp(this, file, "LoanApplication.htm#" + subtopic);
				
			} 
			else 
			{
				Point pt = this.PointToClient(hlpevent.MousePos);
				Control controlHelp = null;
				foreach( Control control in GetAllControls()) 
				{
					if( control.Bounds.Contains(pt) ) 
					{
						controlHelp = control;
						break;
					}
				}
				if (controlHelp != null) 
				{
					String help = toolTip1.GetToolTip(controlHelp);
					if (help.Length > 0) 
					{
						Help.ShowPopup(this, help, hlpevent.MousePos);
						hlpevent.Handled = true;
					}
				}
			}
		}
	}
}

