using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace Dialogs
{
	public class LoanApplicationInfo : Dialogs.LoanApplicationToolTip
	{
		private System.Windows.Forms.ErrorProvider infoProvider;
        private new IContainer components;

		public LoanApplicationInfo()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(LoanApplicationInfo));
            this.infoProvider = new System.Windows.Forms.ErrorProvider(this.components);
            ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.infoProvider)).BeginInit();
            this.SuspendLayout();
            // 
            // label1
            // 
            //this.label1.Location = new System.Drawing.Point(42, 51);
            //this.label1.Size = new System.Drawing.Size(256, 50);
            //// 
            //// applicantNameTextBox
            //// 
            //this.applicantNameTextBox.Location = new System.Drawing.Point(328, 51);
            //this.applicantNameTextBox.Size = new System.Drawing.Size(430, 26);
            //// 
            //// okButton
            //// 
            //this.okButton.Location = new System.Drawing.Point(-362, 108);
            //this.okButton.Size = new System.Drawing.Size(192, 50);
            //// 
            //// cancelButton
            //// 
            //this.cancelButton.Location = new System.Drawing.Point(68, 108);
            //this.cancelButton.Size = new System.Drawing.Size(192, 50);
            //// 
            //// label2
            //// 
            //this.label2.Location = new System.Drawing.Point(42, 120);
            //this.label2.Size = new System.Drawing.Size(256, 48);
            //// 
            //// label3
            //// 
            //this.label3.Location = new System.Drawing.Point(42, 189);
            //this.label3.Size = new System.Drawing.Size(256, 48);
            //// 
            //// applicantPhoneNoTextBox
            //// 
            //this.applicantPhoneNoTextBox.Location = new System.Drawing.Point(328, 120);
            //this.applicantPhoneNoTextBox.Size = new System.Drawing.Size(430, 26);
            //// 
            //// applicantLoanAmountTextBox
            //// 
            //this.applicantLoanAmountTextBox.Location = new System.Drawing.Point(328, 189);
            //this.applicantLoanAmountTextBox.Size = new System.Drawing.Size(430, 26);
            //// 
            //// groupBox1
            //// 
            //this.groupBox1.Location = new System.Drawing.Point(21, 18);
            //this.groupBox1.Size = new System.Drawing.Size(819, 273);
            //// 
            //// buttonApply
            //// 
            //this.buttonApply.Location = new System.Drawing.Point(-136, 108);
            //this.buttonApply.Size = new System.Drawing.Size(192, 50);
            // 
            // infoProvider
            // 
            this.infoProvider.ContainerControl = this;
            this.infoProvider.Icon = ((System.Drawing.Icon)(resources.GetObject("infoProvider.Icon")));
            // 
            // LoanApplicationInfo
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
            this.ClientSize = new System.Drawing.Size(336, 190);
            this.Name = "LoanApplicationInfo";
            this.Load += new System.EventHandler(this.LoanApplicationInfo_Load);
            ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.infoProvider)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		protected override void applicantNameTextBox_Validating(object sender, CancelEventArgs e)
		{
			String error = toolTip1.GetToolTip(applicantNameTextBox);
			SetInfo(applicantNameTextBox, error);
			if (!IsClosing && applicantNameTextBox.Text.Length == 0) 
			{
				e.Cancel = true;
				SetError(applicantNameTextBox, error);
			}
		}

		protected override void applicantLoanAmountTextBox_Validating(object sender, CancelEventArgs e)
		{
			String error = toolTip1.GetToolTip(applicantLoanAmountTextBox);
			SetInfo(applicantLoanAmountTextBox, error);
			if (!IsClosing) 
			{
				try
				{
					Convert.ToDouble( applicantLoanAmountTextBox.Text );
				}
				catch( Exception )
				{
					e.Cancel = true;
					SetError(applicantLoanAmountTextBox, error);
				}
			}
		}

		protected override void applicantPhoneNoTextBox_Validating(object sender, CancelEventArgs e)
		{
			String error = toolTip1.GetToolTip(applicantPhoneNoTextBox);
			SetInfo(applicantPhoneNoTextBox, error);
			if (!IsClosing && !re.IsMatch(applicantPhoneNoTextBox.Text)) 
			{
				e.Cancel = true;
				SetError(applicantPhoneNoTextBox, error);
			} 
		}

		private void LoanApplicationInfo_Load(object sender, System.EventArgs e)
		{
			foreach (Control control in GetAllControls())
			{
				String toolTip = toolTip1.GetToolTip(control);
				if (toolTip.Length > 0) 
				{
					infoProvider.SetError(control, toolTip);
				}
			}
		}

		// Retrieve all controls and all child controls and etc.
		// Make sure to send controls back at lowest depth first
		// so that most child controls are checked for things before
		// container controls, e.g. a TextBox is checked before a
		// GroupBox control
		protected Control[] GetAllControls() 
		{
			ArrayList list = new ArrayList();
			GetAllControls(Controls, list);
			return (Control[])list.ToArray(typeof(Control));
		}
		protected void GetAllControls(Control.ControlCollection controls, ArrayList list) 
		{
			foreach(Control control in controls) 
			{
				if(control.HasChildren) GetAllControls(control.Controls, list);
				list.Add(control);
			}
		}

		protected void SetError(Control control, String error) 
		{
			errorProvider.SetError(control, error);
			infoProvider.SetError(control, null);
		}

		protected void SetInfo(Control control, String error) 
		{
			errorProvider.SetError(control, null);
			infoProvider.SetError(control, error);
		}
	}
}

